# shrinkpack 

Fast, resilient, reproducible builds with npm install.

## Dependencies

- [chalk](https://github.com/chalk/chalk): Terminal string styling done right. Much color.
- [commander](https://github.com/tj/commander.js): the complete solution for node.js command-line programs
- [glob](https://github.com/isaacs/node-glob): a little globber
- [graceful-fs](https://github.com/isaacs/node-graceful-fs): A drop-in replacement for fs, making various improvements.
- [lodash.uniq](https://github.com/lodash/lodash): The lodash method `_.uniq` exported as a module.
- [when](https://github.com/cujojs/when): A lightweight Promises/A+ and when() implementation, plus other async goodies.

## Dev Dependencies

- [commit-release](https://github.com/JamieMason/commit-release): Commit and tag a release for a conventional changelog project.
- [cz-conventional-changelog](https://github.com/commitizen/cz-conventional-changelog): Commitizen adapter following the conventional-changelog format.
- [ghooks](https://github.com/gtramontina/ghooks): Simple git hooks
- [semistandard](https://github.com/Flet/semistandard): All the goodness of `feross/standard` with semicolons sprinkled on top.
- [validate-commit-msg](https://github.com/kentcdodds/validate-commit-msg): Script to validate a commit message follows the conventional changelog standard


## License

MIT

